<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="create_sub_client"
  >
    <v-card>
      <v-card-title class="light">
        Krijo një grup nën: {{ label }}
      </v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col cols="6">
            <v-text-field v-model="request.name" label="Emri*" />
          </v-col>
          <v-col cols="6">
            <price-list-select v-model="request.price_list_type_id" />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <v-spacer />
        <v-btn text @click="close">Anullo</v-btn>
        <f-submit-btn :loading="loading" :disabled="loading" @click="submit" />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<script lang="ts">
import Vue from 'vue'
import api from '../../../../plugins/api'
import { Component, Prop, Watch } from 'vue-property-decorator'
import eventBus from '../../../../plugins/event-bus'
import FSubmitBtn from '../../../../components/buttons/FSubmitBtn.vue'
import PriceListSelect from '../../../../components/selects/PriceListSelect.vue'
@Component({
  components: { PriceListSelect, FSubmitBtn },
})
export default class CreateClientSubGroup extends Vue {
  @Prop({ type: Boolean, required: true }) value
  @Prop({ type: Object, required: true }) clientGroup
  @Watch('clientGroup')
  onClientGroupChange(newValue) {
    this.label = newValue.data.text
  }
  request = {
    price_list_type_id: null,
    parent_id: null,
    name: '',
    margin: 0,
  }
  loading = false
  label = ''

  get selectedValue() {
    return this.value
  }
  set selectedValue(newValue) {
    this.$emit('input', newValue)
  }

  close() {
    this.selectedValue = false
    this.request.name = ''
    this.request.price_list_type_id = null
  }
  submit() {
    if (!this.request.name) return alert('Plotësoni fushat')

    const id = this.clientGroup.id
    this.request.parent_id = id

    this.loading = true
    api()
      .post('api/crm/client-groups', this.request)
      .then(response => {
        alert(response.data.message)
        this.request.name = ''
        this.selectedValue = false
        this.request.price_list_type_id = null

        eventBus.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
}
</script>
